'use strict';

exports.__esModule = true;
exports.default = undefined;

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _objectWithoutProperties2 = require('babel-runtime/helpers/objectWithoutProperties');

var _objectWithoutProperties3 = _interopRequireDefault(_objectWithoutProperties2);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _class, _temp;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _Element2 = require('react-form-controlled/lib/Element');

var _Element3 = _interopRequireDefault(_Element2);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var Alert = (_temp = _class = function (_Element) {
  (0, _inherits3.default)(Alert, _Element);

  function Alert() {
    (0, _classCallCheck3.default)(this, Alert);
    return (0, _possibleConstructorReturn3.default)(this, _Element.apply(this, arguments));
  }

  Alert.prototype.componentDidMount = function componentDidMount() {
    var form = this.getForm();
    form.registerChild(this);
  };

  Alert.prototype.componentWillUnmount = function componentWillUnmount() {
    var form = this.getForm();
    form.unregisterChild(this);
  };

  Alert.prototype.originalValueChanged = function originalValueChanged() {
    this.forceUpdate();
  };

  Alert.prototype.render = function render() {
    var _props = this.props,
        className = _props.className,
        children = _props.children,
        render = _props.render,
        Component = _props.component,
        exact = _props.exact,
        rest = (0, _objectWithoutProperties3.default)(_props, ['className', 'children', 'render', 'component', 'exact']);

    var path = this.getPath();
    var form = this.getForm();

    var errors = form.getErrors(path, exact);
    if (!errors || !errors.length) {
      return null;
    }

    if (typeof children === 'function') {
      return this.replaceChildren(children({ errors: errors }));
    } else if (typeof render === 'function') {
      return this.replaceChildren(render({ errors: errors }));
    } else if (Component) {
      return _react2.default.createElement(Component, (0, _extends3.default)({ errors: errors }, rest));
    } else if (children) {
      return children;
    }

    return _react2.default.createElement(
      'div',
      { role: 'alert', className: className },
      errors.map(function (error) {
        return error.message;
      })
    );
  };

  return Alert;
}(_Element3.default), _class.propTypes = {
  name: _react.PropTypes.oneOfType([_react.PropTypes.string, _react.PropTypes.number]).isRequired,
  exact: _react.PropTypes.bool,
  children: _react.PropTypes.oneOfType([_react.PropTypes.node, _react.PropTypes.func]),
  render: _react.PropTypes.func,
  component: _react.PropTypes.node,
  className: _react.PropTypes.string
}, _temp);
exports.default = Alert;